Merge branch 'jc/for-each-ref' into jc/ref-locking
[git/git.git] / git-resolve.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Linus Torvalds
4 #
5 # Resolve two trees.
6 #
7
8 USAGE='<head> <remote> <merge-message>'
9 . git-sh-setup
10
11 dropheads() {
12 rm -f -- "$GIT_DIR/MERGE_HEAD" \
13 "$GIT_DIR/LAST_MERGE" || exit 1
14 }
15
16 head=$(git-rev-parse --verify "$1"^0) &&
17 merge=$(git-rev-parse --verify "$2"^0) &&
18 merge_name="$2" &&
19 merge_msg="$3" || usage
20
21 #
22 # The remote name is just used for the message,
23 # but we do want it.
24 #
25 if [ -z "$head" -o -z "$merge" -o -z "$merge_msg" ]; then
26 usage
27 fi
28
29 dropheads
30 echo $head > "$GIT_DIR"/ORIG_HEAD
31 echo $merge > "$GIT_DIR"/LAST_MERGE
32
33 common=$(git-merge-base $head $merge)
34 if [ -z "$common" ]; then
35 die "Unable to find common commit between" $merge $head
36 fi
37
38 case "$common" in
39 "$merge")
40 echo "Already up-to-date. Yeeah!"
41 dropheads
42 exit 0
43 ;;
44 "$head")
45 echo "Updating from $head to $merge"
46 git-read-tree -u -m $head $merge || exit 1
47 git-update-ref -m "resolve $merge_name: Fast forward" \
48 HEAD "$merge" "$head"
49 git-diff-tree -p $head $merge | git-apply --stat
50 dropheads
51 exit 0
52 ;;
53 esac
54
55 # We are going to make a new commit.
56 git var GIT_COMMITTER_IDENT >/dev/null || exit
57
58 # Find an optimum merge base if there are more than one candidates.
59 LF='
60 '
61 common=$(git-merge-base -a $head $merge)
62 case "$common" in
63 ?*"$LF"?*)
64 echo "Trying to find the optimum merge base."
65 G=.tmp-index$$
66 best=
67 best_cnt=-1
68 for c in $common
69 do
70 rm -f $G
71 GIT_INDEX_FILE=$G git-read-tree -m $c $head $merge \
72 2>/dev/null || continue
73 # Count the paths that are unmerged.
74 cnt=`GIT_INDEX_FILE=$G git-ls-files --unmerged | wc -l`
75 if test $best_cnt -le 0 -o $cnt -le $best_cnt
76 then
77 best=$c
78 best_cnt=$cnt
79 if test "$best_cnt" -eq 0
80 then
81 # Cannot do any better than all trivial merge.
82 break
83 fi
84 fi
85 done
86 rm -f $G
87 common="$best"
88 esac
89
90 echo "Trying to merge $merge into $head using $common."
91 git-update-index --refresh 2>/dev/null
92 git-read-tree -u -m $common $head $merge || exit 1
93 result_tree=$(git-write-tree 2> /dev/null)
94 if [ $? -ne 0 ]; then
95 echo "Simple merge failed, trying Automatic merge"
96 git-merge-index -o git-merge-one-file -a
97 if [ $? -ne 0 ]; then
98 echo $merge > "$GIT_DIR"/MERGE_HEAD
99 die "Automatic merge failed, fix up by hand"
100 fi
101 result_tree=$(git-write-tree) || exit 1
102 fi
103 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree -p $head -p $merge)
104 echo "Committed merge $result_commit"
105 git-update-ref -m "resolve $merge_name: In-index merge" \
106 HEAD "$result_commit" "$head"
107 git-diff-tree -p $head $result_commit | git-apply --stat
108 dropheads